/*********************************************************************/
/*                                                                   */
/*  This Program Written by Paul Edwards, 3:711/934@fidonet.         */
/*  Released to the Public Domain                                    */
/*                                                                   */
/*********************************************************************/
/*********************************************************************/
/*                                                                   */
/*  showctl - show control characters in a file                      */
/*                                                                   */
/*********************************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "trav.h"

int ufunc(char *fnm, void *ucb);
int goodch(int c);

int main(int argc, char **argv)
{
    if (argc < 2)
    {
        printf("usage: showctl <filename>\n");
        printf("e.g. showctl \"*.asm\"\n");
        return (EXIT_FAILURE);
    }
    trav(*(argv+1), NULL, ufunc, NULL);
    return (0);
}

int ufunc(char *fnm, void *ucb)
{
    FILE *fp;
    static char buf[300];
    char *p;
    int cnt = 0;
    
    fp = fopen(fnm, "r");
    while (fgets(buf, sizeof buf, fp) != NULL)
    {
        int cnt2 = 0;

        cnt++;
        p = buf;
        while (*p != '\0')
        {
            cnt2++;
            if (!goodch(*p))
            {
                printf("%s:%d:%d: %s", fnm, cnt, cnt2, buf);
                break;
            }
            p++;
        }
    }
    fclose(fp);
    return (1);
}

#define MYSTR "ABCDEFGHIJKLMNOPQRSTUVWXYZ" \
              "abcdefghijklmnopqrstuvwxyz" \
              "0123456789" \
              "$@`" \
              "!\"#%&'()*+,-./:" \
              ";<=>?[\\]^_{|}~" \
              " \t\v\f\n"

int goodch(int c)
{
    if (strchr(MYSTR, c) == NULL)
    {
        return (0);
    }
    else
    {
        return (1);
    }
}
